#ifndef A8_UDPLISTENER_H
#define A8_UDPLISTENER_H

namespace a8
{
    struct UdpListenerImpl;
    class UdpListener
    {
    public:
        std::function<void (a8::UdpListener*, int errorId)> on_error;
        std::string bind_address;
        unsigned short bind_port = 0;

    public:
        UdpListener();
        ~UdpListener();

        virtual void OnSocketRead(char*, unsigned int);
        void Open();
        void Close();
        bool IsActive();

    private:
        a8::UdpListenerImpl* impl_ = nullptr;
    };
}

#endif
