#ifndef A8_XPARAMS_H
#define A8_XPARAMS_H

namespace a8
{

    class XParams
    {
    public:

        template <typename T>
        a8::XParams& SetSender(T val)
        {
            sender.Set(val);
            return *this;
        }

        template <typename T>
        a8::XParams& SetParam1(T val)
        {
            param1.Set(val);
            return *this;
        }

        template <typename T>
        a8::XParams& SetParam2(T val)
        {
            param2.Set(val);
            return *this;
        }

        template <typename T>
        a8::XParams& SetParam3(T val)
        {
            param3.Set(val);
            return *this;
        }

        void DeepCopy(a8::XParams& to)
        {
            to = *this;
        }

    public:
        a8::XValue sender;
        a8::XValue param1;
        a8::XValue param2;
        a8::XValue param3;
        long long _sys_field = 0;
    };

}

#endif
