#ifndef A8_JSONLOG_H
#define A8_JSONLOG_H

namespace a8
{

    struct JsonLogImpl;
    class JsonLog : public a8::Singleton<JsonLog>
    {
    private:
        JsonLog();
        friend class a8::Singleton<JsonLog>;

    public:
        ~JsonLog();

        void Init();
        void UnInit();

        void SetLogFileName(const std::string& filename);

        void AddLog(a8::XObject* logobj);

    private:
        void SaveToFileThreadProc();

    private:
        a8::JsonLogImpl* impl_ = nullptr;
    };

}

#endif
