#ifndef A8_STRINGLIST_H
#define A8_STRINGLIST_H

namespace a8
{
    class StringList
    {
    public:

        StringList();
        ~StringList();

        bool LoadFromFile(const char* szFile);
        void Add(const std::string& str);
        int Count();
        std::string String(unsigned int idx);
        void SetText(const char* szText);
        std::string Text();

    private:
        std::vector<std::string> stringitem_list;
    };
}

#endif
